<!doctype html>


<html>
<head>
  <link rel="shortcut icon" href="static/images/favicon.ico" type="image/x-icon">
  <title>Message (Closure Library API Documentation - JavaScript)</title>
  <link rel="stylesheet" href="static/css/base.css">
  <link rel="stylesheet" href="static/css/doc.css">
  <link rel="stylesheet" href="static/css/sidetree.css">
  <link rel="stylesheet" href="static/css/prettify.css">

  <script>
     var _staticFilePath = "static/";
     var _typeTreeName = "goog";
     var _fileTreeName = "Source";
  </script>

  <script src="static/js/doc.js">
  </script>

  <script type="text/javascript" src="//www.google.com/jsapi"></script>
  <script type="text/javascript">
     google.load("visualization", "1", {packages:["orgchart"]});
     var _loadingVisualizations = true;
  </script>

  <meta charset="utf8">
</head>

<body onload="grokdoc.onLoad();">

<div id="header">
  <div class="g-section g-tpl-50-50 g-split">
    <div class="g-unit g-first">
      <a id="logo" href="index.html">Closure Library API Documentation</a>
    </div>

    <div class="g-unit">
      <div class="g-c">
        <strong>Go to class or file:</strong>
        <input type="text" id="ac">
      </div>
    </div>
  </div>
</div>





<div class="colmask rightmenu">
<div class="colleft">
    <div class="col1">
      <!-- Column 1 start -->

<div id="title">
        <span class="fn">proto2.Message</span>
        <span>Extends</span>
        <span class="fn-name">
          
        </span>
</div>

<div class="g-section g-tpl-75-25">
  <div class="g-unit g-first" id="description">
    Abstract base class for all Protocol Buffer 2 messages. It will be
subclassed in the code generated by the Protocol Compiler. Any other
subclasses are prohibited.

  </div>


        <div class="g-unit" id="useful-links">
          <div class="title">Useful links</div>
          <ol>
            <li><a href="local_closure_goog_proto2_message.js.source.html"><span class='source-code-link'>Source Code</span></a></li>
            <li><a href="http://code.google.com/p/closure-library/source/browse/local/closure/goog/proto2/message.js">Git</a></li>
          </ol>
        </div>
</div>






<h2 class="g-first">Inheritance</h2>
<div class='gviz-org-chart-container goog-inline-block'>
<table class='gviz-org-chart' style='display:none'>
  <tr><td>goog.proto2.Message</td><td></td></tr>
</table>
</div>
<div class='gviz-org-chart-container goog-inline-block'>
<table class='gviz-org-chart' style='display:none'>
      <tr><td>Many (7)</td><td>goog.proto2.Message</td></tr>
  </table>
</div>




  <h2>Constructor</h2>
      <div class="fn-constructor">
    goog.proto2.Message(<span></span>)
  </div>



<h2>Instance Methods</h2>


  <div class="legend">
        <span class="key publickey"></span><span>Public</span>
        <span class="key protectedkey"></span><span>Protected</span>
        <span class="key privatekey"></span><span>Private</span>
  </div>







<div>
       <div class="desc">
         Defined in
         <span class="fn-name">
            <a href="class_goog_proto2_Message.html">
              goog.proto2.Message
            </a>
         </span>
       </div>






<div class="section">
  <table class="horiz-rule">


     <tr class="even entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.add"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">add<span class="args">(<span class="arg">field</span>,&nbsp;<span class="arg">value</span>)</span>
        </span>
      </div>


     <div class="entryOverview">
       Adds the given value to the field specified by the
given field descriptor. Note that the field must be repeated.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">field</span>
        : <span class="type"><a href="class_goog_proto2_FieldDescriptor.html">goog.proto2.FieldDescriptor</a></span>
        <div class="entryOverview">The field in which to add the
    the value.</div>
     </td>
   </tr>
     
   <tr class="odd">
     <td>
        <span class="entryName">value</span>
        : <span class="type">*</span>
        <div class="entryOverview">The new value to add to the field.</div>
     </td>
   </tr>
  </table>
      </div>
   
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line319">code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry protected">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.add$Value"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">add$Value<span class="args">(<span class="arg">tag</span>,&nbsp;<span class="arg">value</span>)</span>
        </span>
      </div>


     <div class="entryOverview">
       Adds the value to the *repeating* field indicated by the given tag.

GENERATED CODE USE ONLY. Basis of the add{Field} methods.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">tag</span>
        : <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Number">number</a></span>
        <div class="entryOverview">The field's tag index.</div>
     </td>
   </tr>
     
   <tr class="odd">
     <td>
        <span class="entryName">value</span>
        : <span class="type">*</span>
        <div class="entryOverview">The value to add.</div>
     </td>
   </tr>
  </table>
      </div>
   
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line670">code &raquo;</a>
  </td>
     </tr>


     <tr class="even entry protected">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.array$Values"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">array$Values<span class="args">(<span class="arg">tag</span>)</span>
        </span>
        &#8658; <span>!</span><span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Array">Array</a></span>
      </div>


     <div class="entryOverview">
       Gets the values at the field indicated by the given tag.

GENERATED CODE USE ONLY. Basis of the {field}Array methods.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">tag</span>
        : <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Number">number</a></span>
        <div class="entryOverview">The field's tag index.</div>
     </td>
   </tr>
  </table>
      </div>
   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span>!</span><span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Array">Array</a></span>&nbsp;
            The values found. If none, returns an empty array.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line613">code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.arrayOf"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">arrayOf<span class="args">(<span class="arg">field</span>)</span>
        </span>
        &#8658; <span>!</span><span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Array">Array</a></span>
      </div>


     <div class="entryOverview">
       Returns the array of values found for the given repeated field.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">field</span>
        : <span class="type"><a href="class_goog_proto2_FieldDescriptor.html">goog.proto2.FieldDescriptor</a></span>
        <div class="entryOverview">The field for which to
    return the values.</div>
     </td>
   </tr>
  </table>
      </div>
   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span>!</span><span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Array">Array</a></span>&nbsp;
            The values found.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line228">code &raquo;</a>
  </td>
     </tr>


     <tr class="even entry private">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.checkFieldType_"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">checkFieldType_<span class="args">(<span class="arg">field</span>,&nbsp;<span class="arg">value</span>)</span>
        </span>
      </div>


     <div class="entryOverview">
       Ensures that the value being assigned to the given field
is valid.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">field</span>
        : <span>!</span><span class="type"><a href="class_goog_proto2_FieldDescriptor.html">goog.proto2.FieldDescriptor</a></span>
        <div class="entryOverview">The field being assigned.</div>
     </td>
   </tr>
     
   <tr class="odd">
     <td>
        <span class="entryName">value</span>
        : <span class="type">*</span>
        <div class="entryOverview">The value being assigned.</div>
     </td>
   </tr>
  </table>
      </div>
   
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line695">code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.clear"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">clear<span class="args">(<span class="arg">field</span>)</span>
        </span>
      </div>


     <div class="entryOverview">
       Clears the field specified.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">field</span>
        : <span class="type"><a href="class_goog_proto2_FieldDescriptor.html">goog.proto2.FieldDescriptor</a></span>
        <div class="entryOverview">The field to clear.</div>
     </td>
   </tr>
  </table>
      </div>
   
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line333">code &raquo;</a>
  </td>
     </tr>


     <tr class="even entry protected">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.clear$Field"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">clear$Field<span class="args">(<span class="arg">tag</span>)</span>
        </span>
      </div>


     <div class="entryOverview">
       Clears the field specified by tag.

GENERATED CODE USE ONLY. Basis of the clear{Field} methods.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">tag</span>
        : <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Number">number</a></span>
        <div class="entryOverview">The tag of the field to clear.</div>
     </td>
   </tr>
  </table>
      </div>
   
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line712">code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.clone"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">clone<span class="args">()</span>
        </span>
        &#8658; <span>!</span><span class="type"><a href="class_goog_proto2_Message.html">goog.proto2.Message</a></span>
      </div>


     <div class="entryOverview">
       <span class='nodesc'>No description.</span>
     </div>


    <! -- Method details -->
    <div class="entryDetails">

   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span>!</span><span class="type"><a href="class_goog_proto2_Message.html">goog.proto2.Message</a></span>&nbsp;
            Recursive clone of the message only including
    the known fields.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line458">code &raquo;</a>
  </td>
     </tr>


     <tr class="even entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.copyFrom"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">copyFrom<span class="args">(<span class="arg">message</span>)</span>
        </span>
      </div>


     <div class="entryOverview">
       Recursively copies the known fields from the given message to this message.
Removes the fields which are not present in the source message.

     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">message</span>
        : <span>!</span><span class="type"><a href="class_goog_proto2_Message.html">goog.proto2.Message</a></span>
        <div class="entryOverview">The source message.</div>
     </td>
   </tr>
  </table>
      </div>
   
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line396">code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry protected">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.count$Values"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">count$Values<span class="args">(<span class="arg">tag</span>)</span>
        </span>
        &#8658; <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Number">number</a></span>
      </div>


     <div class="entryOverview">
       Returns the number of values stored in the field by the given tag.

GENERATED CODE USE ONLY. Basis of the {field}Count methods.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">tag</span>
        : <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Number">number</a></span>
        <div class="entryOverview">The tag.</div>
     </td>
   </tr>
  </table>
      </div>
   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Number">number</a></span>&nbsp;
            The number of values.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line629">code &raquo;</a>
  </td>
     </tr>


     <tr class="even entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.countOf"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">countOf<span class="args">(<span class="arg">field</span>)</span>
        </span>
        &#8658; <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Number">number</a></span>
      </div>


     <div class="entryOverview">
       Returns the number of values stored in the given field.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">field</span>
        : <span class="type"><a href="class_goog_proto2_FieldDescriptor.html">goog.proto2.FieldDescriptor</a></span>
        <div class="entryOverview">The field for which to count
    the number of values.</div>
     </td>
   </tr>
  </table>
      </div>
   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Number">number</a></span>&nbsp;
            The count of the values in the given field.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line245">code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.equals"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">equals<span class="args">(<span class="arg">other</span>)</span>
        </span>
        &#8658; <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Boolean">boolean</a></span>
      </div>


     <div class="entryOverview">
       Compares this message with another one ignoring the unknown fields.

     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">other</span>
        : <span class="type">*</span>
        <div class="entryOverview">The other message.</div>
     </td>
   </tr>
  </table>
      </div>
   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Boolean">boolean</a></span>&nbsp;
            Whether they are equal. Returns false if the <code> other</code>
    argument is a different type of message or not a message.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line348">code &raquo;</a>
  </td>
     </tr>


     <tr class="even entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.forEachUnknown"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">forEachUnknown<span class="args">(<span class="arg">callback</span>,&nbsp;<span class="arg">opt_scope</span>)</span>
        </span>
      </div>


     <div class="entryOverview">
       Iterates over all the unknown fields in the message.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">callback</span>
        : <span class="type">function(number, *</span>)
        <div class="entryOverview">A callback method
    which gets invoked for each unknown field.</div>
     </td>
   </tr>
     
   <tr class="odd">
     <td>
        <span class="entryName">opt_scope</span>
        : <span class="type">Object=</span>
        <div class="entryOverview">The scope under which to execute the callback.
    If not given, the current message will be used.</div>
     </td>
   </tr>
  </table>
      </div>
   
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line173">code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.get"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">get<span class="args">(<span class="arg">field</span>,&nbsp;<span class="arg">opt_index</span>)</span>
        </span>
        &#8658; <span class="type">*</span>
      </div>


     <div class="entryOverview">
       Returns the value stored at the field specified by the
given field descriptor.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">field</span>
        : <span class="type"><a href="class_goog_proto2_FieldDescriptor.html">goog.proto2.FieldDescriptor</a></span>
        <div class="entryOverview">The field for which to get the
    value.</div>
     </td>
   </tr>
     
   <tr class="odd">
     <td>
        <span class="entryName">opt_index</span>
        : <span class="type">number=</span>
        <div class="entryOverview">If the field is repeated, the index to use when
    looking up the value.</div>
     </td>
   </tr>
  </table>
      </div>
   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span class="type">*</span>&nbsp;
            The value found or null if none.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line265">code &raquo;</a>
  </td>
     </tr>


     <tr class="even entry protected">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.get$Value"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">get$Value<span class="args">(<span class="arg">tag</span>,&nbsp;<span class="arg">opt_index</span>)</span>
        </span>
        &#8658; <span class="type">*</span>
      </div>


     <div class="entryOverview">
       Gets the value at the field indicated by the given tag.

GENERATED CODE USE ONLY. Basis of the get{Field} methods.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">tag</span>
        : <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Number">number</a></span>
        <div class="entryOverview">The field's tag index.</div>
     </td>
   </tr>
     
   <tr class="odd">
     <td>
        <span class="entryName">opt_index</span>
        : <span class="type">number=</span>
        <div class="entryOverview">If the field is a repeated field, the index
    at which to get the value.</div>
     </td>
   </tr>
  </table>
      </div>
   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span class="type">*</span>&nbsp;
            The value found or null for none.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line565">code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry protected">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.get$ValueOrDefault"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">get$ValueOrDefault<span class="args">(<span class="arg">tag</span>,&nbsp;<span class="arg">opt_index</span>)</span>
        </span>
        &#8658; <span class="type">*</span>
      </div>


     <div class="entryOverview">
       Gets the value at the field indicated by the given tag or the default value
if none.

GENERATED CODE USE ONLY. Basis of the get{Field} methods.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">tag</span>
        : <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Number">number</a></span>
        <div class="entryOverview">The field's tag index.</div>
     </td>
   </tr>
     
   <tr class="odd">
     <td>
        <span class="entryName">opt_index</span>
        : <span class="type">number=</span>
        <div class="entryOverview">If the field is a repeated field, the index
    at which to get the value.</div>
     </td>
   </tr>
  </table>
      </div>
   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span class="type">*</span>&nbsp;
            The value found or the default value if none set.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line592">code &raquo;</a>
  </td>
     </tr>


     <tr class="even entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.getDescriptor"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">getDescriptor<span class="args">()</span>
        </span>
        &#8658; <span>!</span><span class="type"><a href="class_goog_proto2_Descriptor.html">goog.proto2.Descriptor</a></span>
      </div>


     <div class="entryOverview">
       Returns the descriptor which describes the current message.

This only works if we assume people never subclass protobufs.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span>!</span><span class="type"><a href="class_goog_proto2_Descriptor.html">goog.proto2.Descriptor</a></span>&nbsp;
            The descriptor.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line191">code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.getOrDefault"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">getOrDefault<span class="args">(<span class="arg">field</span>,&nbsp;<span class="arg">opt_index</span>)</span>
        </span>
        &#8658; <span class="type">*</span>
      </div>


     <div class="entryOverview">
       Returns the value stored at the field specified by the
given field descriptor or the default value if none exists.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">field</span>
        : <span class="type"><a href="class_goog_proto2_FieldDescriptor.html">goog.proto2.FieldDescriptor</a></span>
        <div class="entryOverview">The field for which to get the
    value.</div>
     </td>
   </tr>
     
   <tr class="odd">
     <td>
        <span class="entryName">opt_index</span>
        : <span class="type">number=</span>
        <div class="entryOverview">If the field is repeated, the index to use when
    looking up the value.</div>
     </td>
   </tr>
  </table>
      </div>
   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span class="type">*</span>&nbsp;
            The value found or the default if none.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line285">code &raquo;</a>
  </td>
     </tr>


     <tr class="even entry private">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.getValueForTag_"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">getValueForTag_<span class="args">(<span class="arg">tag</span>)</span>
        </span>
        &#8658; <span class="type">*</span>
      </div>


     <div class="entryOverview">
       Returns the value for the given tag number. If a lazy deserializer is
instantiated, lazily deserializes the field if required before returning the
value.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">tag</span>
        : <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Number">number</a></span>
        <div class="entryOverview">The tag number.</div>
     </td>
   </tr>
  </table>
      </div>
   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span class="type">*</span>&nbsp;
            The corresponding value, if any.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line526">code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.has"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">has<span class="args">(<span class="arg">field</span>)</span>
        </span>
        &#8658; <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Boolean">boolean</a></span>
      </div>


     <div class="entryOverview">
       Returns whether there is a value stored at the field specified by the
given field descriptor.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">field</span>
        : <span class="type"><a href="class_goog_proto2_FieldDescriptor.html">goog.proto2.FieldDescriptor</a></span>
        <div class="entryOverview">The field for which to check
    if there is a value.</div>
     </td>
   </tr>
  </table>
      </div>
   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Boolean">boolean</a></span>&nbsp;
            True if a value was found.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line211">code &raquo;</a>
  </td>
     </tr>


     <tr class="even entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.has$Value"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">has$Value<span class="args">(<span class="arg">tag</span>)</span>
        </span>
        &#8658; <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Boolean">boolean</a></span>
      </div>


     <div class="entryOverview">
       Returns the whether or not the field indicated by the given tag
has a value.

GENERATED CODE USE ONLY. Basis of the has{Field} methods.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">tag</span>
        : <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Number">number</a></span>
        <div class="entryOverview">The tag.</div>
     </td>
   </tr>
  </table>
      </div>
   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Boolean">boolean</a></span>&nbsp;
            Whether the message has a value for the field.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line512">code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.initDefaults"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">initDefaults<span class="args">(<span class="arg">simpleFieldsToo</span>)</span>
        </span>
      </div>


     <div class="entryOverview">
       Fills in the protocol buffer with default values. Any fields that are
already set will not be overridden.

     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">simpleFieldsToo</span>
        : <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Boolean">boolean</a></span>
        <div class="entryOverview">If true, all fields will be initialized;
    if false, only the nested messages and groups.</div>
     </td>
   </tr>
  </table>
      </div>
   
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line471">code &raquo;</a>
  </td>
     </tr>


     <tr class="even entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.initializeForLazyDeserializer"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">initializeForLazyDeserializer<span class="args">(<span class="arg">deserializer</span>,&nbsp;<span class="arg">data</span>)</span>
        </span>
      </div>


     <div class="entryOverview">
       Initializes the message with a lazy deserializer and its associated data.
This method should be called by internal methods ONLY.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">deserializer</span>
        : <span class="type"><a href="class_goog_proto2_LazyDeserializer.html">goog.proto2.LazyDeserializer</a></span>
        <div class="entryOverview">The lazy deserializer to
  use to decode the data on the fly.</div>
     </td>
   </tr>
     
   <tr class="odd">
     <td>
        <span class="entryName">data</span>
        : <span class="type">*</span>
        <div class="entryOverview">The data to decode/deserialize.</div>
     </td>
   </tr>
  </table>
      </div>
   
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line137">code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.mergeFrom"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">mergeFrom<span class="args">(<span class="arg">message</span>)</span>
        </span>
      </div>


     <div class="entryOverview">
       Merges the given message into this message.

Singular fields will be overwritten, except for embedded messages which will
be merged. Repeated fields will be concatenated.

     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">message</span>
        : <span>!</span><span class="type"><a href="class_goog_proto2_Message.html">goog.proto2.Message</a></span>
        <div class="entryOverview">The source message.</div>
     </td>
   </tr>
  </table>
      </div>
   
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line417">code &raquo;</a>
  </td>
     </tr>


     <tr class="even entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.set"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">set<span class="args">(<span class="arg">field</span>,&nbsp;<span class="arg">value</span>)</span>
        </span>
      </div>


     <div class="entryOverview">
       Stores the given value to the field specified by the
given field descriptor. Note that the field must not be repeated.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">field</span>
        : <span class="type"><a href="class_goog_proto2_FieldDescriptor.html">goog.proto2.FieldDescriptor</a></span>
        <div class="entryOverview">The field for which to set
    the value.</div>
     </td>
   </tr>
     
   <tr class="odd">
     <td>
        <span class="entryName">value</span>
        : <span class="type">*</span>
        <div class="entryOverview">The new value for the field.</div>
     </td>
   </tr>
  </table>
      </div>
   
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line302">code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry protected">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.set$Value"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">set$Value<span class="args">(<span class="arg">tag</span>,&nbsp;<span class="arg">value</span>)</span>
        </span>
      </div>


     <div class="entryOverview">
       Sets the value of the *non-repeating* field indicated by the given tag.

GENERATED CODE USE ONLY. Basis of the set{Field} methods.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">tag</span>
        : <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Number">number</a></span>
        <div class="entryOverview">The field's tag index.</div>
     </td>
   </tr>
     
   <tr class="odd">
     <td>
        <span class="entryName">value</span>
        : <span class="type">*</span>
        <div class="entryOverview">The field's value.</div>
     </td>
   </tr>
  </table>
      </div>
   
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line648">code &raquo;</a>
  </td>
     </tr>


     <tr class="even entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.prototype.setUnknown"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryName">setUnknown<span class="args">(<span class="arg">tag</span>,&nbsp;<span class="arg">value</span>)</span>
        </span>
      </div>


     <div class="entryOverview">
       Sets the value of an unknown field, by tag.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">tag</span>
        : <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Number">number</a></span>
        <div class="entryOverview">The tag of an unknown field (must be &gt;= 1).</div>
     </td>
   </tr>
     
   <tr class="odd">
     <td>
        <span class="entryName">value</span>
        : <span class="type">*</span>
        <div class="entryOverview">The value for that unknown field.</div>
     </td>
   </tr>
  </table>
      </div>
   
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line152">code &raquo;</a>
  </td>
     </tr>


  </table>
</div>
</div>




<h2>Instance Properties</h2>







<div>
       <div class="desc">
         Defined in
         <span class="fn-name">
            <a href="class_goog_proto2_Message.html">
              goog.proto2.Message
            </a>
         </span>
       </div>






<div class="section">
  <table class="horiz-rule">


     <tr class="even entry private">
       <td class="access"></td>





  <a name="goog.proto2.Message.prototype.deserializedFields_"></a>

  <td>


     <div class="arg">
        <img align="left" src="static/images/blank.gif">

        <span class="entryName">deserializedFields_</span>
        : 
     </div>


     <div class="entryOverview">
       A map of those fields deserialized, from tag number to their deserialized
value.

     </div>

  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line61">Code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry private">
       <td class="access"></td>





  <a name="goog.proto2.Message.prototype.fields_"></a>

  <td>


     <div class="arg">
        <img align="left" src="static/images/blank.gif">

        <span class="entryName">fields_</span>
        : 
     </div>


     <div class="entryOverview">
       Stores the field information (i.e. metadata) about this message.

     </div>

  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line46">Code &raquo;</a>
  </td>
     </tr>


     <tr class="even entry private">
       <td class="access"></td>





  <a name="goog.proto2.Message.prototype.lazyDeserializer_"></a>

  <td>


     <div class="arg">
        <img align="left" src="static/images/blank.gif">

        <span class="entryName">lazyDeserializer_</span>
        : <span class="type"><a href="class_goog_proto2_LazyDeserializer.html">goog.proto2.LazyDeserializer</a></span>
     </div>


     <div class="entryOverview">
       The lazy deserializer for this message instance, if any.

     </div>

  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line53">Code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry private">
       <td class="access"></td>





  <a name="goog.proto2.Message.prototype.values_"></a>

  <td>


     <div class="arg">
        <img align="left" src="static/images/blank.gif">

        <span class="entryName">values_</span>
        : 
     </div>


     <div class="entryOverview">
       Stores the field values in this message. Keyed by the tag of the fields.

     </div>

  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line39">Code &raquo;</a>
  </td>
     </tr>


  </table>
</div>
</div>




<h2>Static Methods</h2>






<div class="section">
  <table class="horiz-rule">


     <tr class="even entry private">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.createDescriptor_"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryNamespace">goog.proto2.Message.</span><span class="entryName">createDescriptor_<span class="args">(<span class="arg">messageType</span>,&nbsp;<span class="arg">metadataObj</span>)</span>
        </span>
        &#8658; <span>!</span><span class="type"><a href="class_goog_proto2_Descriptor.html">goog.proto2.Descriptor</a></span>
      </div>


     <div class="entryOverview">
       Creates the metadata descriptor representing the definition of this message.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">messageType</span>
        : <span class="type">function(new:goog.proto2.Message</span>)
        <div class="entryOverview">Constructor for the
    message type to which this metadata applies.</div>
     </td>
   </tr>
     
   <tr class="odd">
     <td>
        <span class="entryName">metadataObj</span>
        : <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Object">Object</a></span>
        <div class="entryOverview">The object containing the metadata.</div>
     </td>
   </tr>
  </table>
      </div>
   
      <div class="detailsSection">
        <b>Returns:</b>&nbsp;<span>!</span><span class="type"><a href="class_goog_proto2_Descriptor.html">goog.proto2.Descriptor</a></span>&nbsp;
            The new descriptor.
      </div>
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line729">code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry public">
       <td class="access"></td>






  <td>
    <a name="goog.proto2.Message.set$Metadata"></a>


     <div class="arg">
       <img align="left" src="static/images/blank.gif">

        <span class="entryNamespace">goog.proto2.Message.</span><span class="entryName">set$Metadata<span class="args">(<span class="arg">messageType</span>,&nbsp;<span class="arg">metadataObj</span>)</span>
        </span>
      </div>


     <div class="entryOverview">
       Sets the metadata that represents the definition of this message.

GENERATED CODE USE ONLY. Called when constructing message classes.


     </div>


    <! -- Method details -->
    <div class="entryDetails">

      <div class="detailsSection">
        <b>Arguments: </b>






<table class="horiz-rule">
     
   <tr class="even">
     <td>
        <span class="entryName">messageType</span>
        : <span>!</span><span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Function">Function</a></span>
        <div class="entryOverview">Constructor for the
    message type to which this metadata applies.</div>
     </td>
   </tr>
     
   <tr class="odd">
     <td>
        <span class="entryName">metadataObj</span>
        : <span class="type"><a href="https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Global_Objects/Object">Object</a></span>
        <div class="entryOverview">The object containing the metadata.</div>
     </td>
   </tr>
  </table>
      </div>
   
  
    </div>
   
  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line754">code &raquo;</a>
  </td>
     </tr>


  </table>
</div>



<h2>Static Properties</h2>






<div class="section">
  <table class="horiz-rule">


     <tr class="even entry private">
       <td class="access"></td>





  <a name="goog.proto2.Message.descriptorObj_"></a>

  <td>


     <div class="arg">
        <img align="left" src="static/images/blank.gif">

        <span class="entryNamespace">goog.proto2.Message.</span><span class="entryName">descriptorObj_</span>
        : 
     </div>


     <div class="entryOverview">
       All instances of goog.proto2.Message should have a static descriptorObj_
property. This is a JSON representation of a Descriptor. The real Descriptor
will be deserialized lazily in the getDescriptor() method.

This declaration is just here for documentation purposes.
goog.proto2.Message does not have its own descriptor.


     </div>

  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line111">Code &raquo;</a>
  </td>
     </tr>


     <tr class="odd entry private">
       <td class="access"></td>





  <a name="goog.proto2.Message.descriptor_"></a>

  <td>


     <div class="arg">
        <img align="left" src="static/images/blank.gif">

        <span class="entryNamespace">goog.proto2.Message.</span><span class="entryName">descriptor_</span>
        : 
     </div>


     <div class="entryOverview">
       All instances of goog.proto2.Message should have a static descriptor_
property. The Descriptor will be deserialized lazily in the getDescriptor()
method.

This declaration is just here for documentation purposes.
goog.proto2.Message does not have its own descriptor.


     </div>

  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line125">Code &raquo;</a>
  </td>
     </tr>


  </table>
</div>



<h2>Enumerations</h2>






<div class="section">
  <table class="horiz-rule">


     <tr class="even entry public">
       <td class="access"></td>





  <a name="goog.proto2.Message.FieldType"></a>

  <td>


     <div class="arg">
        <img align="left" src="static/images/blank.gif">

        <span class="entryNamespace">goog.proto2.Message.</span><span class="entryName">FieldType</span>
        : 
     </div>


     <div class="entryOverview">
       An enumeration defining the possible field types.
Should be a mirror of that defined in descriptor.h.

TODO(user): Remove this alias.  The code generator generates code that
references this enum, so it needs to exist until the code generator is
changed.  The enum was moved to from Message to FieldDescriptor to avoid a
dependency cycle.

Use goog.proto2.FieldDescriptor.FieldType instead.


     </div>

     <div class="entryDetails">
       <div class="detailsSection">
          <b>Constants:</b>
          <table class="horiz-rule">
            <tbody>
              <tr><td>
                <span class="entryName">
                  BOOL
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  BYTES
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  DOUBLE
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  ENUM
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  FIXED32
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  FIXED64
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  FLOAT
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  GROUP
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  INT32
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  INT64
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  MESSAGE
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  SFIXED32
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  SFIXED64
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  SINT32
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  SINT64
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  STRING
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  UINT32
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
              <tr><td>
                <span class="entryName">
                  UINT64
                </span>
                <div class="entryOverview">
                  <span class='nodesc'>No description.</span>
                </div>
             </td></tr>
           </tbody>
         </table>
       </div>
     </div>

  </td>


  <td class="view-code">
     <a href="local_closure_goog_proto2_message.js.source.html#line78">Code &raquo;</a>
  </td>
     </tr>


  </table>
</div>
      <!-- Column 1 end -->
    </div>

        <div class="col2">
          <!-- Column 2 start -->
          <div class="col2-c">
            <h2 id="ref-head">Package proto2</h2>
            <div id="localView"></div>
          </div>

          <div class="col2-c">
            <h2 id="ref-head">Package Reference</h2>
            <div id="sideTypeIndex" rootPath="" current="proto2.Message"></div>
          </div>
          <!-- Column 2 end -->
        </div>
</div>
</div>

</body>
</html>
